Retiarii API Reference
======================

.. contents::

Inline Mutation APIs
--------------------

..  autoclass:: nni.retiarii.nn.pytorch.LayerChoice
    :members:

..  autoclass:: nni.retiarii.nn.pytorch.InputChoice
    :members:

..  autoclass:: nni.retiarii.nn.pytorch.ValueChoice
    :members:

..  autoclass:: nni.retiarii.nn.pytorch.ChosenInputs
    :members:

Graph Mutation APIs
-------------------

..  autoclass:: nni.retiarii.Mutator
    :members:

..  autoclass:: nni.retiarii.Model
    :members:

..  autoclass:: nni.retiarii.Graph
    :members:

..  autoclass:: nni.retiarii.Node
    :members:

..  autoclass:: nni.retiarii.Edge
    :members:

..  autoclass:: nni.retiarii.Operation
    :members:

Trainers
--------

..  autoclass:: nni.retiarii.trainer.FunctionalTrainer
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.lightning.LightningModule
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.lightning.Classification
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.lightning.Regression
    :members:

Oneshot Trainers
----------------

..  autoclass:: nni.retiarii.trainer.pytorch.DartsTrainer
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.EnasTrainer
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.ProxylessTrainer
    :members:

..  autoclass:: nni.retiarii.trainer.pytorch.SinglePathTrainer
    :members:

Strategies
----------

..  autoclass:: nni.retiarii.strategy.Random
    :members:

..  autoclass:: nni.retiarii.strategy.GridSearch
    :members:

..  autoclass:: nni.retiarii.strategy.RegularizedEvolution
    :members:

..  autoclass:: nni.retiarii.strategy.TPEStrategy
    :members:

Retiarii Experiments
--------------------

..  autoclass:: nni.retiarii.experiment.pytorch.RetiariiExperiment
    :members:

..  autoclass:: nni.retiarii.experiment.pytorch.RetiariiExeConfig
    :members:
